/**
	Shamir Secure Secret Sharing
		http://www.rlr-uk.com/tools/SecSplit/SecureSplit.aspx
**/
var SecretSplitting = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=-.", _Modulus: 67, trim : function(str) { return str.replace(new RegExp("[\\s]+$", "g"), ""); }, rndGenerate64: function(size) { var strRand = ""; var intRand; for (var n = 0; n < size; n++) { intRand = Math.floor(Math.random() * 64); strRand += this._keyStr.charAt(intRand); } return strRand; }, simpleSplit: function(input1, input2) { var strOutput = ""; var intTemp; for (var n = 0; n < input1.length; n++) { intTemp = this._keyStr.indexOf(input1.charAt(n)) ^ this._keyStr.indexOf(input2.charAt(n)); if (intTemp < 64) { strOutput += this._keyStr.charAt(intTemp); } else { strOutput += this._keyStr.charAt(64); } } return strOutput; }, cryptoSplit: function(strInput, n, k) { var strOutput = new Array(n); var Equation = new Array(k); var intTemp; for (var i = 0; i < n; i++) { strOutput[i] = this._keyStr.charAt(k) + this._keyStr.charAt(i + 1); } for (var i = 0; i < strInput.length; i++) { if (strInput.charAt(i) == "=") { continue; } Equation[0] = this._keyStr.indexOf(strInput.charAt(i)); for (var j = 1; j < k; j++) { Equation[j] = Math.floor(Math.random() * this._Modulus); } for (var j = 0; j < n; j++) { intTemp = 0; for (var l = 0; l < k; l++) { intTemp += Equation[l] * Math.pow(j + 1, l); } intTemp = intTemp % this._Modulus; strOutput[j] += this._keyStr.charAt(intTemp); } } return strOutput; }, cryptoJoin: function(strInput) { var strOutput = ""; var k = this._keyStr.indexOf(strInput[0].charAt(0)); var Points = new Array(k); var intTemp; if (strInput.length < k) { return "Tm8gUXVvcnVtIQ=="; } for (var j = 0; j < k; j++) { Points[j] = 1.0; for (var l = 0; l < k; l++) { if (l != j) { Points[j] *= -this._keyStr.indexOf(strInput[l].charAt(1)); intTemp = (this._keyStr.indexOf(strInput[j].charAt(1)) - this._keyStr.indexOf(strInput[l].charAt(1))); for (var m = 1; m < this._Modulus; m++) { if ((m * this._Modulus + 1) % intTemp == 0) { intTemp = ((m * this._Modulus + 1) / intTemp) % this._Modulus; break; } } Points[j] *= intTemp; } } } for (var i = 2; i < strInput[1].length; i++) { intTemp = 0; for (var j = 0; j < k; j++) { intTemp += (this._keyStr.indexOf(strInput[j].charAt(i)) * 1.0) * Points[j]; } intTemp = intTemp % this._Modulus; if (intTemp < 0) { intTemp += this._Modulus; } strOutput += this._keyStr.charAt(intTemp); } if ((strOutput.length % 4) == 2) { strOutput += "=="; } else if ((strOutput.length % 4) == 3) { strOutput += "="; } return strOutput; } }
var Base64 = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function(input) { var output = ""; var chr1, chr2, chr3, enc1, enc2, enc3, enc4; var i = 0; input = Base64._utf8_encode(input); while (i < input.length) { chr1 = input.charCodeAt(i++); chr2 = input.charCodeAt(i++); chr3 = input.charCodeAt(i++); enc1 = chr1 >> 2; enc2 = ((chr1 & 3) << 4) | (chr2 >> 4); enc3 = ((chr2 & 15) << 2) | (chr3 >> 6); enc4 = chr3 & 63; if (isNaN(chr2)) { enc3 = enc4 = 64; } else if (isNaN(chr3)) { enc4 = 64; } output = output + this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) + this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4); } return output; }, decode: function(input) { var output = ""; var chr1, chr2, chr3; var enc1, enc2, enc3, enc4; var i = 0; input = input.replace(/[^A-Za-z0-9\+\/\=]/g, ""); while (i < input.length) { enc1 = this._keyStr.indexOf(input.charAt(i++)); enc2 = this._keyStr.indexOf(input.charAt(i++)); enc3 = this._keyStr.indexOf(input.charAt(i++)); enc4 = this._keyStr.indexOf(input.charAt(i++)); chr1 = (enc1 << 2) | (enc2 >> 4); chr2 = ((enc2 & 15) << 4) | (enc3 >> 2); chr3 = ((enc3 & 3) << 6) | enc4; output = output + String.fromCharCode(chr1); if (enc3 != 64) { output = output + String.fromCharCode(chr2); } if (enc4 != 64) { output = output + String.fromCharCode(chr3); } } output = Base64._utf8_decode(output); return output; }, _utf8_encode: function(string) { string = string.replace(/\r\n/g, "\n"); var utftext = ""; for (var n = 0; n < string.length; n++) { var c = string.charCodeAt(n); if (c < 128) { utftext += String.fromCharCode(c); } else if ((c > 127) && (c < 2048)) { utftext += String.fromCharCode((c >> 6) | 192); utftext += String.fromCharCode((c & 63) | 128); } else { utftext += String.fromCharCode((c >> 12) | 224); utftext += String.fromCharCode(((c >> 6) & 63) | 128); utftext += String.fromCharCode((c & 63) | 128); } } return utftext; }, _utf8_decode: function(utftext) { var string = ""; var i = 0; var c = c1 = c2 = 0; while (i < utftext.length) { c = utftext.charCodeAt(i); if (c < 128) { string += String.fromCharCode(c); i++; } else if ((c > 191) && (c < 224)) { c2 = utftext.charCodeAt(i + 1); string += String.fromCharCode(((c & 31) << 6) | (c2 & 63)); i += 2; } else { c2 = utftext.charCodeAt(i + 1); c3 = utftext.charCodeAt(i + 2); string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63)); i += 3; } } return string; } }
